using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_AddingColumns
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{			
			GridEngineFactory.Factory = new GroupingEngineFactory();
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button3 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(584, 552);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			// 
			// button3
			// 
			this.button3.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.button3.Location = new System.Drawing.Point(360, 576);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(240, 24);
			this.button3.TabIndex = 3;
			this.button3.Text = "Add Column";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(616, 614);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private int numberParentRows = 5;
		private int numberChildRows = 10;

		# region DataTables

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("Lines");
			
			dt.Columns.Add(new DataColumn("TitleName",typeof(string))); //lower case p
			dt.Columns.Add(new DataColumn("Airs",typeof(string)));
			dt.Columns.Add(new DataColumn("Length",typeof(int)));
			dt.Columns.Add(new DataColumn("CurrentRate",typeof(double)));
			dt.Columns.Add(new DataColumn("RevenueTypeID",typeof(int)));
			dt.Columns.Add(new DataColumn("InventoryTypeID",typeof(string)));
			dt.Columns.Add(new DataColumn("TotalSpot",typeof(int)));
			dt.Columns.Add(new DataColumn("TotalDollar",typeof(double)));

			for(int i = 1; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = string.Format("TitleName{0}",i);
				dr[1] = string.Format("Airs{0}",i);
				dr[2] = i * i * 30;
				dr[3] = i * i * 30 * 40;
				dr[4] = i;
				dr[5] = string.Format("TypeID{0}",i);
				dr[6] = 15 * i;
				dr[7] = i * i * 30 * 40 + 1000 * 15 * i;
				dt.Rows.Add(dr); 
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P

			dt.Columns.Add(new DataColumn("dropCol")); //upper case P

			
			for(int i = 1; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		# endregion

		DataSet ds;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();

			ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});

			this.gridGroupingControl1.DataSource = ds.Tables[0];			
			new OrderForm(this.gridGroupingControl1);
		}
		
		int c = 1;
		private void button3_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableControl.BeginUpdate();			
			foreach(DataTable dt in ds.Tables)
			{
				dt.Columns.Add(new DataColumn("Test"+c.ToString()));
				for(int i = 0; i < dt.Rows.Count; ++i)
					dt.Rows[i][dt.Columns.Count-1] = "Hello!";
				dt.AcceptChanges(); 
				ds.AcceptChanges();
			}
			this.gridGroupingControl1.TableControl.EndUpdate(true);
			this.gridGroupingControl1.TableDescriptor.ResetVisibleColumns();
			c++;
		}
	}
}
